Skip to content
This repository has been archived by the owner. It is now read-only.
Permalink
Browse files
8161558: ListIterator should not discard cause on exception
Reviewed-by: smarks
  • Loading branch information
Kiran Sidhartha Ravikumar committed Mar 13, 2020
1 parent cd7d175 commit fa069be2f2abcf203d87f0fad77aeb93bff2e79b
@@ -374,7 +374,7 @@ public E next() {
return next;
} catch (IndexOutOfBoundsException e) {
checkForComodification();
throw new NoSuchElementException();
throw new NoSuchElementException(e);
}
}

@@ -418,7 +418,7 @@ public E previous() {
return previous;
} catch (IndexOutOfBoundsException e) {
checkForComodification();
throw new NoSuchElementException();
throw new NoSuchElementException(e);
}
}

@@ -46,6 +46,33 @@ public NoSuchElementException() {
super();
}

/**
* Constructs a {@code NoSuchElementException} with the specified detail
* message and cause.
*
* @param s the detail message, or null
* @param cause the cause (which is saved for later retrieval by the
* {@link #getCause()} method), or null
* @since 15
*/
public NoSuchElementException(String s, Throwable cause) {
super(s, cause);
}

/**
* Constructs a {@code NoSuchElementException} with the specified cause.
* The detail message is set to {@code (cause == null ? null :
* cause.toString())} (which typically contains the class and
* detail message of {@code cause}).
*
* @param cause the cause (which is saved for later retrieval by the
* {@link #getCause()} method)
* @since 15
*/
public NoSuchElementException(Throwable cause) {
super(cause);
}

/**
* Constructs a {@code NoSuchElementException}, saving a reference
* to the error message string {@code s} for later retrieval by the
@@ -0,0 +1,114 @@
/*
* Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
*
* This code is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License version 2 only, as
* published by the Free Software Foundation.
*
* This code is distributed in the hope that it will be useful, but WITHOUT
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
* version 2 for more details (a copy is included in the LICENSE file that
* accompanied this code).
*
* You should have received a copy of the GNU General Public License version
* 2 along with this work; if not, write to the Free Software Foundation,
* Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
*
* Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
* or visit www.oracle.com if you need additional information or have any
* questions.
*/

/*
* @test
* @bug 8161558
* @summary ListIterator should not discard cause on exception
* @run testng CheckForIndexOutOfBoundsException
*/

import java.util.List;
import java.util.AbstractList;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.NoSuchElementException;

import org.testng.annotations.Test;

import static org.testng.Assert.assertNotNull;
import static org.testng.Assert.assertTrue;
import static org.testng.Assert.fail;

// Fixed size list containing two elements

class MyList extends AbstractList<String> {

private static final int SIZE = 2;

public String get(int i) {
if (i >= 0 && i < SIZE) {
return "x";
} else {
throw new IndexOutOfBoundsException(i);
}
}

public int size() {
return SIZE;
}
}

@Test
public class CheckForIndexOutOfBoundsException {

List<String> list = new MyList();


@Test
public void checkIteratorNext() {
var iterator = list.iterator(); // position at start
try {
for (int i = 0; i <= list.size(); i++) {
iterator.next();
}
fail("Failing checkIteratorNext() - NoSuchElementException should have been thrown");
} catch (NoSuchElementException e) {
checkAssertOnException(e);
}
}

@Test
public void checkListIteratorNext() {
var iterator = list.listIterator(list.size()); // position at end
try {
iterator.next();
fail("Failing checkListIteratorNext() - NoSuchElementException should have been thrown");
} catch (NoSuchElementException e) {
checkAssertOnException(e);
}
}

@Test
public void checkListIteratorPrevious() {
var iterator = list.listIterator(0); // position at start
try {
iterator.previous();
fail("Failing checkListIteratorPrevious() - NoSuchElementException should have been thrown");
} catch (NoSuchElementException e) {
checkAssertOnException(e);
}
}

private void checkAssertOnException(NoSuchElementException e) {
var cause = e.getCause();
assertNotNull(cause, "Exception.getCause()");
assertTrue(cause instanceof IndexOutOfBoundsException, "Exception.getCause() should be an " +
"IndexOutOfBoundsException");
var msg = e.getMessage();
assertNotNull(msg, "Exception.getMessage()");
assertTrue(msg.contains("IndexOutOfBoundsException"), "Exception.getMessage() should " +
"contain the string 'IndexOutOfBoundsException'");
}
}

0 comments on commit fa069be

Please sign in to comment.